package com.itsoulos.spinnerwithicons;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.provider.ContactsContract;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;

import org.json.JSONArray;
import org.json.JSONException;

import java.util.ArrayList;

public class CustomAdapter extends ArrayAdapter {
    private Context context = null;
    private ArrayList<SpinnerItem> data = new ArrayList<SpinnerItem>();


    public CustomAdapter(Context ctx, int resource, ArrayList<SpinnerItem> dx) {
        super(ctx, resource, dx);
        context = ctx;
        data = dx;
    }


    public View getView(int position, View convertView, ViewGroup parent) {
        LinearLayout l = new LinearLayout(context);
        l.setOrientation(LinearLayout.VERTICAL);

        LinearLayout line = new LinearLayout(context);
        l.addView(line);
        LinearLayout.LayoutParams lparams = (LinearLayout.LayoutParams) line.getLayoutParams();
        lparams.width = Global.width;
        lparams.height = 8 * Global.height / 100;
        line.setLayoutParams(lparams);

        ImageView im = new ImageView(context);
        line.addView(im);

        Bitmap bm = BitmapFactory.decodeResource(context.getResources(), data.get(position).getIcon());
        double ratio = bm.getWidth() * 1.0 / bm.getHeight();
        int newwidth = 5 * Global.width / 100;
        int newheight = (int) (newwidth / ratio);
        bm = bm.createScaledBitmap(bm, newwidth, newheight, true);
        im.setImageBitmap(bm);


        TextView text = new TextView(context);
        text.setTextSize(20);
        text.setText(data.get(position).getName());
        line.addView(text);

        LinearLayout.LayoutParams iparams = (LinearLayout.LayoutParams) im.getLayoutParams();
        iparams.leftMargin = 5 * Global.width / 100;
        iparams.width = newwidth;
        iparams.height = newheight;
        iparams.topMargin=lparams.height/10;
        im.setLayoutParams(iparams);

        LinearLayout.LayoutParams tparams = (LinearLayout.LayoutParams) text.getLayoutParams();
        tparams.height = 2 * iparams.height;
        tparams.width = Global.width / 4;
        tparams.rightMargin = iparams.leftMargin;
        tparams.leftMargin = Global.width - iparams.leftMargin - iparams.width - tparams.rightMargin - tparams.width;
        tparams.topMargin=iparams.topMargin;
        text.setLayoutParams(tparams);

        View v = new View(context);
        v.setBackgroundColor(Color.DKGRAY);
        l.addView(v);
        LinearLayout.LayoutParams vparams = (LinearLayout.LayoutParams) v.getLayoutParams();
        vparams.width = Global.width;
        vparams.height = 3;
        v.setLayoutParams(vparams);


        return l;
    }

    @Override
    public View getDropDownView(int position, View convertView, ViewGroup parent) {
        return getView(position, convertView, parent);
    }
}
